/**
 ** On-Screen-Display for Noatun
 ** Copyright (c) 2001, Flaming Sword Productions
 ** All Rights Reserved under the BSD License
 **
 ** This plug-in REQUIRES that you have the X On-Screen-Display (xosd)
 ** libraries installed.
 **
 ** $Id: kosd.h,v 1.8 2002/05/31 15:29:56 brian Exp $
 **/
#ifndef		__KOSD_H__
#define		__KOSD_H__
#include	<sys/types.h>
#include	<qqueue.h>
#include	<qpixmap.h>
#include	<qobject.h>
#include	<qtimer.h>
#include	<qlabel.h>

/**
 ** class KOSD: This is brian's dirty OSD hack.  It's only here to be a
 ** replacement for XOSD, which requires noatun to be pthreaded (which it's
 ** not).  Rather than compile noatun as a threaded app, I'll just take the
 ** easy approach for now.  (this object will go away when KDE3 becomes stable)
 **/
class		KOSD: public QLabel {
Q_OBJECT
public:
enum Status {
	Stopped = 0,
	Playing = 1,
	Paused = 2
};

enum Position {
	Bottom = 0,
	Top = 1
};

enum Style {
	Normal = 0,
	Shadowed = 1
};
		KOSD();
		~KOSD();

public slots:
	void		setPosition( Position );
	void		setStyle( Style );
	void		setTextColor( const QColor& );
	void		setTextFont( const QFont& );
	void		showText( const QString& );
	void		showVolume();
	void		setStatus( KOSD::Status );
	void		setVolume( int );
	void		setQuieterVolume( bool );
	void		setHideTimeout( u_int );

private slots:
	void		_showLabel();
	void		_setPosition();
	QString		_volumeString();
	QString		_statusString();
	void		_push( const QString& );
	QString		_pop();

protected:
	void		paintEvent( QPaintEvent* );
	void		resizeEvent( QResizeEvent* );

	Position	_position;
	Style		_style;
	Status		_status;
	QFont		_font;
	QColor		_color;
	int		_volume;
	bool		_quieterVolume;
	int		_hideTimeout;

	QQueue<QString>	_messageStack;
	QString		_lastMessage;

	QTimer		*_displayTimer;
};

inline void		KOSD::setQuieterVolume( bool b ) { _quieterVolume = b; }
inline void		KOSD::setHideTimeout( u_int i ) { 
	_hideTimeout = i;
}

#endif
