/**
 ** On-Screen-Display for Noatun
 ** Copyright (c) 2001, Flaming Sword Productions
 ** All Rights Reserved under the BSD License
 **
 ** $Id: osdconfig.cpp,v 1.12 2002/05/31 15:29:56 brian Exp $
 **/
#include	<kdebug.h>
#include	<kconfig.h>
#include	<kfontdialog.h>
#include	<kcolorbtn.h>
#include	<klocale.h>
#include	<player.h>
#include	<plugin.h>
#include	<qobject.h>
#include	<qcheckbox.h>
#include	<qcombobox.h>
#include	<qhbox.h>
#include	<qlabel.h>
#include	<qslider.h>
#include	<qlayout.h>
#include	<qpainter.h>
#include	<noatun/pref.h>
#include	<noatun/app.h>
#include	"osdconfig.h"
#include	"kosd.h"

#define		SAMPLE		">> "+i18n("Play")+"   "+i18n("Volume:")+" ||||||------\n"+\
					i18n("This is Sample Text")

/**
 ** DemoWidget::DemoWidget(): Construct ourselves.
 **/
		DemoWidget::DemoWidget( QWidget *parent )
		:QWidget( parent ) {

	setStyle( Normal );
	_alignment = AlignBottom;
}

/**
 ** DemoWidget::paintEvent(): 
 **/
void		DemoWidget::paintEvent( QPaintEvent *pe ) {
QPainter	p(this);

	QBrush b( Qt::gray, Qt::SolidPattern );
	p.fillRect( rect(), b );
	p.setFont( _font );

	QPixmap px;
	QPainter pxp;

	switch( _style ) {

		case( Outline ):
			px = QPixmap( width(), height() );
			pxp.begin( &px );
			pxp.setPen( _color );
			pxp.setBrush( _color );
			pxp.drawText( rect(), _alignment, SAMPLE );
			pxp.end();

			/**
			 ** In order to make this work, we ought to stretch
			 ** the pixmap's mask out a touch.
			 **/
			if( px.mask() ) {
				QWMatrix m;
				px.xForm( m );
			}
		break;

		// SHADOWED style.  Draw the text, and add in a nice
		// purty, NON-ALPHA-RENDERED (!@#%!#$) drop-shadow.
		case( Shadowed ):
			p.setPen( Qt::black );
			p.setBrush( Qt::black );
			p.drawText( rect().x()+1, rect().y()+1, rect().width(), rect().height(),
				_alignment, SAMPLE );
			p.setPen( _color );
			p.setBrush( _color );
			p.drawText( rect(), _alignment, SAMPLE );
		break;

		// NORMAL style.  Just text.  Nothing more, nothing
		// less..
		default:
			p.setPen( _color );
			p.setBrush( _color );
			p.drawText( rect(), _alignment, SAMPLE );
		break;

	}
}

/**
 ** OSDConfig::OSDConfig(): CONSTRUCTOR. 
 **/
		OSDConfig::OSDConfig( QObject *o )
		:CModule(
			i18n("On-Screen Display"), 
			i18n("Configure Noatun On-Screen Display"), 
			"kscreensaver",
			o) 
		{

	QVBoxLayout *_layout;
	_layout = new QVBoxLayout(this, KDialog::marginHint(), KDialog::spacingHint());

	const QColor *_defaultc = new QColor(Qt::red);
        const QFont *_defaultf = new QFont("fixed", 20, QFont::Bold);

	QHBox *fhb = new QHBox( this );
	new QLabel(i18n("Text Position:"), fhb);
	QComboBox *foo = new QComboBox( fhb );
	connect(foo,SIGNAL(activated(int)), this, SLOT(_positionChanged(int)));
	foo->insertItem( i18n("Bottom") );
	_position = 0;
	foo->insertItem( i18n("Top") );

	(new QLabel(i18n("Text Style:"), fhb))->setAlignment( AlignRight|AlignVCenter );
	QComboBox *foo2 = new QComboBox( fhb );
	foo2->insertItem( i18n("Plain") );
	foo2->insertItem( i18n("Shadow") );
	connect(foo2,SIGNAL(activated(int)), this, SLOT(_styleChanged(int)));

	_layout->addWidget( fhb );

	QHBox *fhb2 = new QHBox( this );
	QPushButton *fpb = new QPushButton(i18n("Select Font"), fhb2 );
	_color = new KColorButton( fhb2 );

	_layout->addWidget( fhb2 );

	QHBox *fhb3 = new QHBox( this );
	_volIsOnlyVol = new QCheckBox( fhb3 );
	_volIsOnlyVol->setText( i18n("When adjusting the volume, show only the volume.") );
	_layout->addWidget( fhb3 );

	QHBox *fhb4 = new QHBox( this );
	_showFilename = new QCheckBox( fhb4 );
	_showFilename->setText( i18n("Show filename instead of track info.") );
	_layout->addWidget( fhb4 );

	QHBox *fhb5 = new QHBox( this );
	fhb5->setSpacing( KDialog::spacingHint() );
	QLabel *lbl = new QLabel( i18n("Hide Timeout:"), fhb5 );
	_hideTimeout = new QSlider( 1, 10, 1, 10, Horizontal, fhb5 );
	_hideTimeout->setTickmarks( QSlider::Below );
	_hideTimeoutLabel = new QLabel( i18n("10 seconds"), fhb5 );
	_hideTimeoutLabel->setAlignment( AlignRight );
	_hideTimeoutLabel->setFixedWidth( _hideTimeoutLabel->sizeHint().width() );
	connect(_hideTimeout, SIGNAL( valueChanged( int ) ), this, SLOT( _sliderChanged( int ) ) );
	_layout->addWidget( fhb5 );

	_layout->addStretch();

	/**
	 ** try to replicate our situation here..
	 **/
	lbl = new QLabel( i18n("(Ok, imagine that this is your monitor...)"), this );
	lbl->setFixedHeight( lbl->sizeHint().height() );
	_layout->addWidget( lbl );

	QHBox *df = new QHBox(this);
	df->setFrameStyle( QFrame::Panel );
	df->setFrameShadow( QFrame::Sunken );

	_demo2 = new DemoWidget( df );
	_demo2->setFixedHeight( 80 );

	df->setFixedHeight( _demo2->height() + 2 );

	_layout->addWidget( df );

/**
 ** QTimer in milliseconds.  10 minutes = 10*60*1000...
 **/

	KGlobal::config()->setGroup("Noatun OSD");
        foo->setCurrentItem(_position = KGlobal::config()->readNumEntry("TextPosition", _position));
        _color->setColor(KGlobal::config()->readColorEntry("TextColor", _defaultc));
	_demo2->setFont( _font = KGlobal::config()->readFontEntry("Font", _defaultf));
	foo2->setCurrentItem(_style = KGlobal::config()->readNumEntry("TextStyle", 0));
	_volIsOnlyVol->setChecked( KGlobal::config()->readBoolEntry("QuieterVolume", false) );
	_demo2->setColor( _color->color() );
	_showFilename->setChecked( KGlobal::config()->readBoolEntry("FilenameOnly", false) );
	emit _hideTimeout->setValue( KGlobal::config()->readNumEntry("HideTimeout", 1) );

	_positionChanged( _position );
	_styleChanged( _style );

	connect( fpb, SIGNAL(pressed()), this, SLOT(_changeFont()));
	connect(_color,SIGNAL(changed(const QColor &)), _demo2, SLOT(setColor(const QColor&)));
}

/**
 ** OSDConfig::save(): 
 **/
void		OSDConfig::save() {

        KConfig *config=KGlobal::config();
        config->setGroup("Noatun OSD");
        config->writeEntry("Font", _font);
        config->writeEntry("TextPosition", _position);
        config->writeEntry("TextStyle", _style);
        config->writeEntry("TextColor", _color->color());
	config->writeEntry("QuieterVolume", _volIsOnlyVol->isChecked() );
	config->writeEntry("FilenameOnly", _showFilename->isChecked() );
	config->writeEntry("HideTimeout", _hideTimeout->value() );
        config->sync();
        emit saved();
}

/**
 ** OSDConfig::_positionChanged(): Text position changed.
 **/
void		OSDConfig::_positionChanged( int i ) {

	_position = i;
	switch( _position ) {
		case(1): _demo2->setAlignment( AlignTop ); break;
		default: _demo2->setAlignment( AlignBottom ); break;
	}
	_demo2->repaint();
}

/**
 ** OSDConfig::_styleChanged(): Text style changed.
 **/
void		OSDConfig::_styleChanged( int i ) {

	_style = i;
	switch( i ) {
		case(1): _demo2->setStyle( DemoWidget::Shadowed ); break;
		default: _demo2->setStyle( DemoWidget::Normal ); break;
	}
	_demo2->repaint();
}

/**
 ** OSDConfig::_changeFont(): 
 **/
void		OSDConfig::_changeFont() {

        KFontDialog dlg( this, "Font Selector", false, true, QStringList(), true );
	dlg.setFont( _font );
	if( dlg.exec() == KDialog::Accepted ) {
		_font = dlg.font();
		_demo2->setFont( _font );
		_demo2->repaint();
	}
}

/**
 ** OSDConfig::_sliderChanged(): Somebody went and dinked with the slider.
 **/
void		OSDConfig::_sliderChanged( int val ) {


	QString s( val == 1?i18n("second"):i18n("seconds") );
	_hideTimeoutLabel->setText( i18n( "%1 %2" ).arg( val ).arg( s ) );
}
