/**
 ** On-Screen-Display for Noatun
 ** Copyright (c) 2001, Flaming Sword Productions
 ** All Rights Reserved under the BSD License
 **
 ** $Id: osdconfig.h,v 1.8 2002/05/31 15:29:56 brian Exp $
 **/
#ifndef		__OSDCONFIG_H__
#define		__OSDCONFIG_H__
#include	<player.h>
#include	<plugin.h>
#include	<qslider.h>
#include	<qobject.h>
#include	<noatun/app.h>
#include	<noatun/pref.h>
#include	<kcolorbtn.h>

/**
 ** class DemoWidget: Provide a "sneak preview" of what's in store.  It's not
 ** the best, but hopefully will rock before too long...
 **/
class		DemoWidget: public QWidget {
Q_OBJECT
public:
enum Style {
	Normal,		// Just draw the text.
	Shadowed,	// Draw the text with a simulated drop-shadow.
	Outline		// By various voodoo, draws a black outline around the text.
};

		DemoWidget( QWidget * = 0L );

public slots:
inline void		setStyle( Style s = Normal ) { _style = s; };
inline void		setFont( const QFont& f ) { _font = f; };
inline void		setColor( const QColor& f ) { _color = f; };
inline void		setAlignment( int a ) { _alignment = a; };
	void		paintEvent( QPaintEvent * );

protected:
	Style		_style;
	QFont		_font;
	QColor		_color;
	int		_alignment;
};

/**
 ** class OSDConfig: Allow the user to configure this module.
 **/
class		QComboBox;
class		QCheckBox;
class		OSDConfig: public CModule {
Q_OBJECT
public:

		OSDConfig( QObject * );

virtual	void		save();

public slots:
	void		_positionChanged(int);
	void		_styleChanged(int);
	void		_changeFont();

signals:
	void		saved();

private slots:
	void		_sliderChanged( int value );

protected:
	QComboBox	*_textPosition, *_textStyle;
	int		_position;
	int		_style;
	KColorButton	*_color;
	QFont		_font;
	QLabel		*_demo;
	QCheckBox	*_volIsOnlyVol;
	QCheckBox	*_showFilename;
	QSlider		*_hideTimeout;
	QLabel		*_hideTimeoutLabel;

	DemoWidget	*_demo2;
};

#endif
